#include "morph.h"

void step_1 (Model *);
void step_2 (Model *, Model *, int *, int, int, int, Intersection **);
void step_3 ( Model *, Model *, Intersection *, int *, int, int);
void step_4 (Model *, Model *, int *, int, int, int);
void step_6 (Model *, Model *,Modeltopo *, Intersection *, int  *, int *);
void write_to_geomview (Model *);


int power (int a, int b) { // fonction annexe calculant la puissance d un entier par un entier

  int c;

  c= a;
  a= 1;

  while (b!=0) {

    a=c*a;

    b--;

  }

    return a;

  }



void triangulate_faces (Modeltopo *m) { //on triangule les faces. pas tres dur, vu que chaque face a au maximum 6 points

  int i,j;
  Face *newfaces;

  newfaces= (Face *) malloc (4*(m->nbf)*sizeof(Face));

  j=0;

  for (i=0;i<m->nbf;i++) {

    if (m->f[i].p4==-1) { 

      newfaces[j]= m->f[i];
      j++;
 

    } else if (m->f[i].p5==-1) { 

      newfaces[j].p1= m->f[i].p1;
      newfaces[j].p2= m->f[i].p2;
      newfaces[j].p3= m->f[i].p4;
      newfaces[j].p4= -1;

      newfaces[j+1].p1= m->f[i].p2;
      newfaces[j+1].p2= m->f[i].p3;
      newfaces[j+1].p3= m->f[i].p4;
      newfaces[j+1].p4= -1;

      j=j+2;

    }
    else if (m->f[i].p6==-1) {

      newfaces[j].p1= m->f[i].p1;
      newfaces[j].p2= m->f[i].p2;
      newfaces[j].p3= m->f[i].p5;
      newfaces[j].p4= -1;

      newfaces[j+1].p1= m->f[i].p2;
      newfaces[j+1].p2= m->f[i].p4;
      newfaces[j+1].p3= m->f[i].p5;
      newfaces[j+1].p4= -1;

      newfaces[j+2].p1= m->f[i].p2;
      newfaces[j+2].p2= m->f[i].p3;
      newfaces[j+2].p3= m->f[i].p4;
      newfaces[j+2].p4= -1;

      j=j+3;

    } else { 

      newfaces[j].p1= m->f[i].p1;
      newfaces[j].p2= m->f[i].p2;
      newfaces[j].p3= m->f[i].p6;
      newfaces[j].p4= -1;

      newfaces[j+1].p1= m->f[i].p2;
      newfaces[j+1].p2= m->f[i].p5;
      newfaces[j+1].p3= m->f[i].p6;
      newfaces[j+1].p4= -1;

      newfaces[j+2].p1= m->f[i].p2;
      newfaces[j+2].p2= m->f[i].p3;
      newfaces[j+2].p3= m->f[i].p5;
      newfaces[j+2].p4= -1;

      newfaces[j+3].p1= m->f[i].p3;
      newfaces[j+3].p2= m->f[i].p4;
      newfaces[j+3].p3= m->f[i].p5;
      newfaces[j+3].p4= -1;

      j=j+4;

    }

  }

  m->nbf= j;
  m->f= newfaces; // attention en faisant ca on detruit irreversiblement la  topologie soigneusement construite du modele; mais c' est bon pour le format geomview.


}

void interpolate (Modeltopo *combined, Model *Ma, Model *Mb, int n, char *s) {

  char *st;
  int i,j,k,l,m,h;
  Model newmodel;


  translate_from_orig (Ma);
  translate_from_orig (Mb);

  newmodel.nbv= combined->nbv;

  //  newmodel.nbv= combined->nbva;
  //  newmodel.nbv= combined->nbvb;

  newmodel.points = (Vertex *) malloc (newmodel.nbv*sizeof(Vertex));


  for (i=0;i<combined->nbv;i++) {

    newmodel.points[i].enb= combined->points[i].enb;
    newmodel.points[i].r= 0.500;
    newmodel.points[i].g= 0.500;
    newmodel.points[i].b= 0.500;
    newmodel.points[i].a= 0.000;

      }

    newmodel.nbe = combined->nbe;
    


    /* pas de couleur pour l instant

    newmodel.points[i].r= Ma->points[i].r;
    newmodel.points[i].g= Ma->points[i].g;
    newmodel.points[i].b= Ma->points[i].b;
    newmodel.points[i].a= Ma->points[i].a;


    newmodel.points[i].edges= (int *) malloc (combined->points[i].enb*sizeof(int));

    for (j=0;j<combined->points[i].enb;j++) {

      newmodel.points[i].edges[j]= combined->points[i].edges[j];  

    }

  

    */


    /*

    for (j=0;j<combined->nbe;j++) {

      newmodel.e[j].p1= combined->e[j].p1;
      newmodel.e[j].p2= combined->e[j].p2;
      newmodel.e[j].f1= combined->e[j].f2;
      newmodel.e[j].f2= combined->e[j].f2;  

    }

    */

    newmodel.nbf = combined->nbf;
    newmodel.f= (Face *) malloc (newmodel.nbf*sizeof (Face));
    

    for (j=0;j<combined->nbf;j++) {

      newmodel.f[j].p1= combined->f[j].p1;
      newmodel.f[j].p2= combined->f[j].p2;
      newmodel.f[j].p3= combined->f[j].p3;
      newmodel.f[j].p4= combined->f[j].p4;  
      newmodel.f[j].p5= combined->f[j].p5;
      newmodel.f[j].p6= combined->f[j].p6;
      newmodel.f[j].e1= combined->f[j].e1;
      newmodel.f[j].e2= combined->f[j].e2;  
      newmodel.f[j].e3= combined->f[j].e3;
      newmodel.f[j].e4= combined->f[j].e4;
      newmodel.f[j].e5= combined->f[j].e5;
      newmodel.f[j].e6= combined->f[j].e6;  

    }

    k=0;

      while (s[k]!=0) {

	k++;}


 h=0;
 m=n;
 
 while ((m/(power(10,h)))!=0) {

   h++;

 }

 st= (char*) malloc ((k+4+h)*sizeof(char));

 for (i=0;i<k;i++) {

   st[i]=s[i];

 }

 st[k]='_';
 st[k+1]='f';

#ifdef debug

#else //initialization for Geomview

   printf ("(geometry example { : foo } )\n");

#endif

 for (i=0;i<n+1;i++) {


   for (j=0;j<newmodel.nbv;j++) { // ici on fait l interpolation linaire

     newmodel.points[j].x= Ma->points[j].x + ((double)i/(double)n)*(Mb->points[j].x-Ma->points[j].x);
     newmodel.points[j].y= Ma->points[j].y + ((double)i/(double)n)*(Mb->points[j].y-Ma->points[j].y);
     newmodel.points[j].z= Ma->points[j].z + ((double)i/(double)n)*(Mb->points[j].z-Ma->points[j].z);

   }

   h=0;
   m=i;
 
   while ((m/((power(10,h))))!=0) {

     h++;

   }

   if (h!=0) {

   h--;

   }

   for (l=h;l>-1;l--) {

     st[k+2+(h-l)]= 48+(m/(power(10,l)));

     m= m-(m/(power(10,l)))*(power(10,l));

   }

   st[k+3+h]= 0;


#ifdef debug 

   if (i==0) {

   write_geomfile ("debug_dir/model_a_morphed.geom",&newmodel);

   }

 if (i==n) {

   write_geomfile ("debug_dir/model_b_morphed.geom",&newmodel);

   }


#else // we communicate directly with geomview

   printf("(read geometry {define foo \n");

   write_to_geomview (&newmodel);

   printf("})\n");

   sleep(0.04); // works with 250 frames / second. Should be 25 frames / second though (0.04*25=1) ??

#endif

      
 }

}


int main (int argc, char **argv) {

  FILE *fp;
  int i;
  Model Ma, Mb;
  Modeltopo combined;
  int *maptob, *maptoa; 
  Intersection *intersections;
  Vertex *vtx;
  float f1,f2,f3,f4,f5,f6;
  double ran;

  char *namea, *nameb, *namec;
  int  number_of_frames, max_edges, inter_mem_page, intersections_mem_page, edge_mem_page;

  // init
  intersections = NULL;


  //  g= gauss_3 (1.0,1.0,2.0,-5.3,6.78,2.45,3.14,1.0,4.3,3.2,2.2,1.2);

  //  printf ("%f",g);

  // printf("\n");


  if (argc <2) {

    printf("I need a configuration file. Syntax in configuration file: morph model_a model_b morphing\n");
    printf("number_of_frames max_edges memory_for_new_vertexes memory_for_total_intersections memory_for_intersections_in_edges\n");
    printf("centerax centeray centeraz centerbx centerby centerbz");
    printf("\n");
    return 0;

  }


  if ( (fp = fopen( argv[1], "r" )) == NULL ) {
    fprintf(stderr,"Could not open the configuration file %s.\n",namea);
    return(0);
  }

  //number_of_frames= atoi (argv[4]); // ATTENTION POUR L INSTANT number_of_frames doit etre inferieur a 10 !! sinon plantage !!
  //max_edges= atoi (argv[5]); // ca represente le nombre maximum d edges qu un point de a ou b peut avoir
  //inter_mem_page= atoi (argv[6]);
  //intersections_mem_page= atoi (argv[7]);
  //edge_mem_page= atoi (argv[8]);

  //  namea= argv[1];
  //nameb= argv[2];
  //namec= argv[3];

  namea= (char *) malloc (30 * sizeof(char));
  nameb= (char *) malloc (30 * sizeof(char));
  namec= (char *) malloc (30 * sizeof(char));

  fscanf (fp,"%s %s %s", namea, nameb, namec);

  fscanf (fp, "%d %d %d %d %d",&number_of_frames,&max_edges,&inter_mem_page,&intersections_mem_page,&edge_mem_page);

  fscanf (fp, "%f %f %f %f %f %f",&f1,&f2,&f3,&f4,&f5,&f6);

  


	  ran= random();
  Ma.center.x = (double) f1 + ((double) ran * 0.000000000000001);
	  ran= random();
  Ma.center.y = (double) f2 + ((double) ran * 0.000000000000001) ;
	  ran= random();
  Ma.center.z = (double) f3 + ((double) ran * 0.000000000000001);
	  ran= random();
  Mb.center.x = (double) f4 + ((double) ran * 0.000000000000001);
	  ran= random();
  Mb.center.y = (double) f5 + ((double) ran * 0.000000000000001);
	  ran= random();
  Mb.center.z = (double) f6 + ((double) ran * 0.000000000000001);

  

  /* sans bruit;

  Ma.center.x = (double) f1;
  Ma.center.y = (double) f2;
  Ma.center.z = (double) f3;
  Mb.center.x = (double) f4;
  Mb.center.y = (double) f5;
  Mb.center.z = (double) f6;

  */
  
  // read in model a from disk;
  
  readgeomfile(namea, &Ma, max_edges);

  // read in model b from disk;

  readgeomfile(nameb, &Mb, max_edges);


#ifdef debug

 printf("We have correctly read in the data files...\n");

 write_topology (&Ma,0);
 write_topology (&Mb,Ma.nbv);

#endif

  // ok now we move the vertex:

  translate_to_orig (&Ma);
  translate_to_orig (&Mb);

  step_1(&Ma);
  step_1(&Mb);


  
#ifdef debug

  printf("We will write insides...\n");

  write_inside ("debug_dir/model_a_inside.geom",&Ma);
  write_inside ("debug_dir/model_b_inside.geom",&Mb);

  //exit(0);

#endif

  // exit(0);
  
 

  // ici on va crer un nouveau tableau de vertex... contenant les vertex de a et ceux de b
  // ouh la c est n importe quoi au niveau memoire


  vtx= (Vertex *) malloc((Ma.nbv+Mb.nbv) * sizeof(Vertex));

 for (i=0;i<Ma.nbv;i++) {

   vtx[i]= Ma.points[i];

 }

 for (i=0;i<Mb.nbv;i++) {

   vtx[Ma.nbv+i]= Mb.points[i];

 }

 Ma.points= (Vertex *) malloc((Ma.nbv+Mb.nbv) * sizeof(Vertex));
 Mb.points= (Vertex *) malloc((Ma.nbv+Mb.nbv) * sizeof(Vertex));

 for (i=0;i<Ma.nbv+Mb.nbv;i++) {
   
   Ma.points[i]= vtx[i];
   Mb.points[i]= vtx[i];

 }


 Ma.vtxmempage= inter_mem_page;
 Mb.vtxmempage= inter_mem_page;

 combined.nbva = Ma.nbv;
 combined.nbvb = Ma.nbv + Mb.nbv;
 combined.nbv= Ma.nbv + Mb.nbv;

 Ma.nbv= combined.nbv;
 Mb.nbv= combined.nbv;
 Ma.maxvtx= combined.nbv;
 Mb.maxvtx= combined.nbv;

 // ici on "update" le modele b en ajoutant le nombre de vertex de a a tous les indices de points dans les edges et les faces
 // puisqu on a decale tous les indices de combined.nbva

 update_model (&Mb, combined.nbva);

// reservation memoire pour les tableau donnat la face d un point dans l autre modele

 maptoa= (int *) malloc((combined.nbv) * sizeof(int));
 maptob= (int *) malloc((combined.nbv) * sizeof(int));

 for (i=0;i<combined.nbv; i++) { // on met tout maptoa  -1. Ncessaire pour propagate_faces
   
   maptoa[i]= -1; 
   
 }


#ifdef debug


 printf("Models have been translated and projected on the unit sphere. Now computing intersections...\n");

#endif

 step_2(&Ma, &Mb, maptob, intersections_mem_page, edge_mem_page, combined.nbvb,  &intersections);

#ifdef debug

 printf("Done. We update the list of intersections on the edges of B...\n");

#endif

 combined.nbv= Ma.nbv;

 step_3 (&Ma, &Mb, intersections, maptoa, edge_mem_page, combined.nbvb);

#ifdef debug

 for (i=0;i<combined.nbva;i++) {

      printf("%d: %d\n", i, maptob[i]);

 }

 for (i=combined.nbva;i<combined.nbvb;i++) {

      printf("%d: %d\n", i, maptoa[i]);

 }


 printf("Passed. We calculate the coordinates of all the vertexes in BOTH models...\n");

#endif

 step_4 (&Ma, &Mb, maptob, 0, combined.nbva, combined.nbvb) ;

 step_4 (&Mb, &Ma, maptoa, combined.nbva, combined.nbvb, combined.nbvb) ; // note: ce step_4 correspond, avec ces parametres, au step 5...

 combined.points= (Vertextopo *) malloc(combined.nbv * sizeof(Vertextopo)); // on alloue la memoire pour tous les points de model.combined

 for (i=0;i<combined.nbvb;i++) { // On alloue la memoire ici pour les edges de a et b.

   combined.points[i].edges = (int *) malloc (max_edges*sizeof(int));
 }

 for (i=combined.nbvb;i<combined.nbv;i++) { // On alloue la memoire ici de chaque point d intersection. seulement 4 normalement

   combined.points[i].edges = (int *) malloc (4*sizeof(int));

 }

 combined.e= (Edgetopo *) malloc((Ma.nbe+Mb.nbe+2*(combined.nbv-combined.nbvb)) * sizeof(Edgetopo)); // reservation memoire pour les edges. chaque intersection ajoute DEUX edges

 combined.f= (Face *) malloc((Ma.nbe+Mb.nbe+2*(combined.nbv-combined.nbvb)) * sizeof(Face)); // autant de faces que d edges (on compte TRES large..

 combined.nbf= 0;

#ifdef debug

 printf("The last step: we create the merged topology...\n");

#endif

 step_6 (&Ma, &Mb, &combined,intersections, maptoa, maptob);

#ifdef debug

 printf("Unbelievable. The merged topology was created without major errors! Now writing output to disk...\n");

#endif

 triangulate_faces (&combined);

 interpolate (&combined,&Ma,&Mb, number_of_frames, namec);

#ifdef debug

 printf("Completed. Enjoy your new 3D Morphing!\n");

#endif

 return 0;


}
