#include <math.h>
#include <malloc.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>

typedef struct {
  double x,y,z; // coords
  float r,g,b,a; // colors
  double xp,yp,zp; //coords on the unit sphere
  int *edges;
  int enb;
} Vertex;

typedef struct {
  int *edges;
  int enb;
} Vertextopo;

typedef struct {
  int p1, p2;
  int *inter;
  int f1,f2;
  int nbi;
  int nbimax;
  int other_way;
} Edge ;

typedef struct {
  int p1, p2;
  int f1,f2;
} Edgetopo ;

typedef struct {
  int p1, p2, p3, p4 ,p5, p6;
  int e1,e2,e3, e4, e5, e6;
} Face ;

typedef struct {
  Vertex *points;
  Face *f;
  Edge *e;
  int nbv;
  int nbe;
  int nbf;
  int maxvtx;
  int vtxmempage;
  Vertex center;

} Model;

typedef struct {
  Vertextopo *points;;
  Face *f;
  Edgetopo *e;
  int nbv;
  int nbe;
  int nbf;
  int nbva;
  int nbvb;

} Modeltopo;


typedef struct {
  int edgea;
  int edgeb;
} Intersection;

void translate_from_orig (Model *);
void translate_to_orig (Model *);
void update_model (Model *, int) ;
int readgeomfile(char *, Model *, int);
void create_mem_edge (Edge *, int );
int create_mem_inter ( Intersection **, int , int) ;
void create_mem ( Model *);
int test_face (Vertex *, Face *, Model *) ;
double gauss_3 ( double , double , double , double ,double , double , double ,double , double , double ,double ,double );
double gauss_2 (double , double , double , double , double , double );
Vertex vect_proj_orig (Vertex );
Vertex gauss_3_vect_fond (Vertex *,Vertex *,Vertex *,Vertex *);
Vertex intersect (Vertex *a1, Face *, Model *);
Vertex vect (Vertex , Vertex );
double gauss_3_vect ( Vertex *,Vertex *, Vertex *, Vertex *);
int specific_test (Vertex *, Vertex *, Vertex *, Model *, Edge *, Model *, Edge *);
Vertex intersect_edges (Model *, Edge *, Model *, Edge *);


// deboguage

#ifdef debug

void write_inside ( char *, Model *);
void write_topology ( Model *, int) ;
void write_geomfile ( char *, Model *);

#endif
