#include "morph.h"

int search_face (Vertex *, Model *);

void step_1 (Model *M) {

  double a,b,c,d;
  int i;

  for (i=0; i< M->nbv; i++) {

    a=M->points[i].x;
    b=M->points[i].y;
    c=M->points[i].z;
    
    d= sqrt(a*a+b*b+c*c);

    M->points[i].xp= a/d;
    M->points[i].yp= b/d;
    M->points[i].zp= c/d;
  }

}


void reverse (Model *m) {
 
  int i,j,k;
  int *t;

  for (i=0;i<m->nbe;i++) {

    if (m->e[i].other_way==1) {

      k= m->e[i].nbi;


      t= (int *) malloc (k*sizeof(int));

      for (j=0;j<k;j++) {

	t[j]= m->e[i].inter[k-1-j];

      }

 for (j=0;j<k;j++) {

   m->e[i].inter[j]= t[j];

      }  

      free (t);

    }

  }

}


void step_2 (Model *a, Model *b, int *maptob , int intermempage, int edgemempage, int nbvb, Intersection **intersections) {

  Vertex k,l,m;
  int nWL, nCL;
  int *WL, *CL;
  int *used_edges;
  int v2a,v1a,i,nfb,nea,neb,nIT,maxinter;

  // Intersection *intersections;
  Face fb;
  Edge *ea,*eb;

  nWL= 0;
  nIT= 0;
  nCL= 0;

  WL= (int*) malloc ((a->nbe+5)*sizeof(int));
  CL= (int*) malloc ((b->nbe+5)*sizeof(int));

  maxinter= 0;


#ifdef debug

  printf("\nDebugging Information. Format:\nNew vertex number: Intersections of Number of edge (model A) - Number of edge (model B)\n\n");

#endif

  //  maxinter= intermempage; on le met pas pour avoir une reservation memoire tout au debut

  used_edges = (int *) malloc(a->nbe * sizeof(int));

  maptob[0] = search_face(&(a->points[0]), b);


  // add the edges originating at v1a to Work List WL

  v1a=0;
  v2a=0;

  for (i=0;i<a->points[v1a].enb;i++) {

    WL[i]=a->points[v1a].edges[i];
    used_edges[a->points[v1a].edges[i]]=1;

  }

  nWL= a->points[v1a].enb;

  while (nWL!=0) {

    nWL--;
    nea= WL[nWL];
    ea= &(a->e[nea]);
    
    if ((v1a== ea->p1 )|(v2a == ea->p1 )) {

      v1a= ea->p1;
      v2a= ea->p2;
    }

    else {

      v1a= ea->p2;
      v2a= ea->p1;
      ea->other_way= 1;

    }
    nfb=maptob[v1a];
    fb= b->f[nfb];

    //add edges of fb to candidate list CL

    CL[nCL]=fb.e1;
    CL[nCL+1]=fb.e2;
    CL[nCL+2]=fb.e3;
    nCL=nCL+3;

    //

    while (nCL!=0) {

      nCL= nCL-1;
      neb= CL[nCL];
      eb= &(b->e[neb]);
      
      // attention on calcule ici l intersection de ea et eb

      k= intersect_edges (a,ea,b,eb); // k va etre l intersection sur la unit sphere des great circles contenant ea et eb

      if (specific_test (&k,&l,&m,a,ea,b,eb)==1) { // si k est bien l intersection de ea et eb on ajoute cette intersection au modele;


#ifdef debug

	printf("%d: %d - %d\n", nIT+nbvb , nea, neb);

#endif 

	if (a->nbv == a->maxvtx) { // la on fait des tests memoire
	    
	  create_mem (a);}
	
	if (b->nbv == b->maxvtx) { // la on fait des tests memoire

	  create_mem (b);}
	 
	a->points[a->nbv]= l; // l contient les coordonnes dans le modele a du nouveau point
	b->points[b->nbv]= m; // et m les coordonnes dans b...

	  a->points[a->nbv].edges = (int *) malloc (sizeof(int));
	  a->points[a->nbv].edges[0]= nea;

	  b->points[b->nbv].edges = (int *) malloc (sizeof(int));
	  b->points[b->nbv].edges[0]= neb;

	// on update la structure d intersection. On fait un test memoire

	if (nIT== maxinter) { 

	  maxinter= create_mem_inter ( intersections, nIT, intermempage);

	}

	(*intersections)[nIT].edgea=nea;
	(*intersections)[nIT].edgeb=neb;

	// ATTENTION ICI il y avait un gros bug. On peut mettre les intersections a l'envers...


	if (ea->nbi == ea->nbimax) { 

	  create_mem_edge ( ea,edgemempage) ; 

	}

	ea->inter[ea->nbi]= nIT+nbvb;

	if (eb->nbi == eb->nbimax) { 

	  create_mem_edge ( eb,edgemempage) ; 

	}

	eb->inter[eb->nbi]= nIT+nbvb;
	  
	nIT++;
	ea->nbi++;
	eb->nbi++;	  
	a->nbv++;
	b->nbv++;

	// fb =  autre face de eb	  

	if (eb->f1 == nfb) {
	  nfb= eb->f2;
	}
	else { nfb= eb->f1;}

	fb= b->f[nfb];

	// ajout des deux autres edges de fb

	if (fb.e1==neb) {
	  CL[nCL]=fb.e2;
	  CL[nCL+1]=fb.e3; }
	else if (fb.e2==neb) {
	  CL[nCL]=fb.e1;
	  CL[nCL+1]=fb.e3; }
	else {
	  CL[nCL]=fb.e1;
	  CL[nCL+1]=fb.e2; }
       
	nCL=nCL+2;

      }

      // fin boucle if


    }

    // fin boucle while

    maptob[v2a]= nfb;

    // add unused edges

    for (i=0;i<a->points[v2a].enb;i++) {

      if (used_edges[a->points[v2a].edges[i]]==0) {

	WL[nWL]=a->points[v2a].edges[i];
	nWL++;
	used_edges[a->points[v2a].edges[i]]=1;
      }
    }   
  }

  //  return intersections;


    reverse(a);

#ifdef debug

    printf("Number of Intersections: %d\n",nIT);

    


#endif

}


void  propagate_faces (Model *b, int *prob, int prob_length, int *maptoa ) { // fonction annexe qui remplit tous les maptoa pas encore traits

  int i,bool;

  bool=0;

  for (i=0;i<prob_length;i++ ) { 

    if (prob[i]!=-1) {

      if (((maptoa[b->e[prob[i]].p1]==-1)|(maptoa[b->e[prob[i]].p2]==-1))&&((maptoa[b->e[prob[i]].p1]=!-1)|(maptoa[b->e[prob[i]].p2]=!-1))) {

	if (maptoa[b->e[prob[i]].p1]==-1) { 

	  maptoa[b->e[prob[i]].p1]= maptoa[b->e[prob[i]].p2];

	}

	else { 

	  maptoa[b->e[prob[i]].p2]= maptoa[b->e[prob[i]].p1];

	}

	prob[i]=-1;
	bool=1;

      }

    }
    
    
  }

/*

  for (i=0;i<prob_length;i++) {

     if (prob[i]!=-1) {

       bool=1;

*/

  if (bool==1) {

#ifdef debug

  printf("Propagate faces...");

#endif

 propagate_faces ( b, prob, prob_length, maptoa);

  }    

}


void step_3 ( Model *a, Model *b, Intersection *c, int *maptoa, int edgemempage, int nbvb) {

  int i,j,k,u,bool,l,prob_length;
  int ffin1,ffin2;
  int v1b,v2b;
  int *t,*t2,*prob;
  Edge e;

  prob_length= 0;

  t= (int*) malloc (2*(a->nbe+1)*sizeof(int)); // reservations memoires: t va etre le tableau des intersections d un edge.. Au max il y aura une intersection avec chaque edge de A. Dans t on mettra les faces de l edge de A correspondant au point d intersection

  t2= (int*) malloc ((a->nbe+1)*sizeof(int)); // encore un tableau pour stocker le numero de l intersection

  prob= (int*) malloc ((b->nbe+1)*sizeof(int)); // prob ca va etre un tableau ou on met les edges sans intersections de b



  for (i=0;i<b->nbe;i++) { // bon la on boucle sur tous les edges de b

    v1b=b->e[i].p1;
    v2b=b->e[i].p2;
    u=0; // u ca va etre l indice courant du tableau des faces obtenues en parcourant l'edge
    


    if (b->e[i].nbi==0) {
     
      prob[prob_length]=i;
      prob_length++;
 
    } else {


      for (j=0; j<b->e[i].nbi; j++) {
	
	k= b->e[i].inter[j]; // k un des points de l edge intersect
	e= a->e[c[k-nbvb].edgea]; // c[k-nbvb].edgea l edge de a concern...
	
	t[u]=e.f1;
	t[u+1]=e.f2;
	t2[j]= k;
	u=u+2; 
      }

      

    
      k=0;
      bool=0;

      // la on trouve les deux faces finales ffin1 et ffin2

      while (bool==0) {

	l=t[k]; // face dont on va rechercher le nombre d occurences dans le tableau t.


	for (j=0;j<u;j++) {

	  if (t[j]==l) { // une occurence de plus...

	    bool++; }
	}

	if (bool==1) { // si on trouve qu une face n apparait qu une seule fois c est qu elle est finale
	  ffin1=l; // donc on la sauvegarde
  
	}
	else {
	  
	  bool=0;
	}

	k++;

      }

      bool=0;

      while (bool==0) {  // la pareil... on recherche la second face finale

	l=t[k];

	for (j=0;j<u;j++) {

	  if (t[j]==l) {

	    bool++; }
	}

	if (bool==1) {

	  ffin2=l; 
	}

	else {

	  bool=0;

	}

	k++;

      }

      // maintenant on teste pour savoir si c'est ffin1 ou ffin2 qui contient v1b

      if (test_face (&(b->points[v1b]), &(a->f[ffin1]), a)) { // Attention: apparemment ici aucun moyen de faire ce test de maniere topologique !!
	// en effet... les points dans le tableau edge.inter sont completement desordonns...
	// peut etre une solution pour accelerer mais je n'en ai aps trouve en 10mn de reflexion

	maptoa[v1b]= ffin1;
	maptoa[v2b]= ffin2;

      } else {
   
	maptoa[v1b]= ffin2;
	maptoa[v2b]= ffin1;

	k=ffin1;
	ffin1=ffin2;
	ffin2=k;

      }

      //ok c'est fait
      // maintenant on peut y aller en passant d une face voisine a l autre...

      j=0;

      while (ffin1!=ffin2) { // tant qu on est pas arrive a la face finale on continue

	bool=0;
	k=0; // on remet k a 0 pour tout parcourir

	while (bool==0) { // la on boucle en recherchant la face suivante (ffin1)

	  if (t[k]==ffin1) {
   
	    bool=1;

	    if ((k%2)==0) {

	      b->e[i].inter[j]= t2[k/2];
	      ffin1 = t[k+1];
	      t[k+1]= -1;
	      t[k]= -1;
	      j++;

	    } 

	    else {	     

	      b->e[i].inter[j]= t2[(k-1)/2];
	      ffin1= t[k-1];
	      t[k-1]= -1;
	      t[k]= -1;
	      j++;

	    }

	  }

	  k++;
 
	}
 
      }

      
 
    }

  } // voila a ce stade tous les edges ont leur points correctement ordonns.

  // Ici il est necessaire de remplir les maptoa des vertex qui n avaient aucun edge comportant des intersections... ca peut arriver.
  // on fait ca de maniere topologique... c est surement plus rapide qu en refaisant tous les calculs.

  if ( prob_length !=0) {

  propagate_faces ( b, prob, prob_length, maptoa); // voila c'est fait !

  }

}

// le step 4 de l'algo. Il cree les coordonnees

Vertex intersect_vertex_face (Vertex *a1,Face *f, Model *m) { // calcule l intersection de la droite passant par l origine et le point a (projete) et le plan de la face f du modele m

  // ATTENTION TRES IMPORTANT: il faut que la face soit calcule PROJETEE

  double l;
  Vertex k,a2,a3,b;

  k.enb=0;

  
  // la on calcule deux vecteurs definissant le plan (a partir des points de la face f)

  a2= vect (m->points[f->p3],m->points[f->p1]);
  a3= vect (m->points[f->p3],m->points[f->p2]);

  // la on a besoin en collone resultat du systeme d un point du plan (ici p1)

  b.x=m->points[f->p1].x;
  b.y=m->points[f->p1].y;
  b.z=m->points[f->p1].z;

  // la on calcule le vecteur directeur de la droite. Ici on va prendre directo a1

  // on resoud le systeme

  l= gauss_3_vect (&a2,&a3,a1,&b);

  if (l<0) { k.enb=-1;}

  // puis on renvoit le bon vertex

  k.x=l*a1->x;
  k.y=l*a1->y;
  k.z=l*a1->z;

  return k;

}


void step_4 (Model *a, Model *b, int* maptob, int start, int nbv, int nbvt) { // nbvt nombre de vertexes des duex modeles (tous sauf intersections)

  //double a11,a12,a13,a21,a22,a23,a31,a32,a33,b1,b2,b3;

  double u,v,w;
  int i;
  Vertex k,a1,a2,a3,c;


  for (i=start;i<nbv;i++) {

    // calculate barycentric coordinates...
 
    a1= vect_proj_orig (b->points[b->f[maptob[i]].p1]);
    a2= vect_proj_orig (b->points[b->f[maptob[i]].p2]);
    a3= vect_proj_orig (b->points[b->f[maptob[i]].p3]);

    c= vect_proj_orig(a->points[i]);


    k= gauss_3_vect_fond  ( &a1, &a2, &a3, &c);

    // n= normorig (k);

    u= k.x;
    v= k.y;
    w= k.z;


    b->points[i].x= u*b->points[b->f[maptob[i]].p1].x+v*b->points[b->f[maptob[i]].p2].x+w*b->points[b->f[maptob[i]].p3].x;
    b->points[i].y= u*b->points[b->f[maptob[i]].p1].y+v*b->points[b->f[maptob[i]].p2].y+w*b->points[b->f[maptob[i]].p3].y;
    b->points[i].z= u*b->points[b->f[maptob[i]].p1].z+v*b->points[b->f[maptob[i]].p2].z+w*b->points[b->f[maptob[i]].p3].z;

    b->points[i]= intersect_vertex_face (&(b->points[i]),&(b->f[maptob[i]]),b); // ici il faut faire tres attention qu on ne travaille plus en coordonnes projetes...
   
    /*
 
    if ( (point_is_in_face (&(b->points[i]),&(b->f[maptob[i]]),b)==0)) {


	 // | (b->points[i].enb==-1) ) {

      printf("Error.\n");

  }

    */
	
    /*
										  
    if (i==start) {

      write_geomfile_addedpoint ( "aaa.geom", b,b->f[maptob[i]].p1,b->f[maptob[i]].p2, nbv, nbv,nbvt, b->points[i]);

      printf("Done.\n");

      // exit(0);


    }
    
    */

  }

  for (i=nbvt;i<a->nbv;i++) { // la on calcule les coordonnes des intersections

    // on avait auparavant stock dans a->points[i].xp le paramtre de l intersection sur l edge. et dans a->points[i].edges[0]  le numero de l edge

    a->points[i].x= a->points[a->e[a->points[i].edges[0]].p1].x +(a->points[i].xp)*(a->points[a->e[a->points[i].edges[0]].p2].x-a->points[a->e[a->points[i].edges[0]].p1].x);
    a->points[i].y= a->points[a->e[a->points[i].edges[0]].p1].y +(a->points[i].xp)*(a->points[a->e[a->points[i].edges[0]].p2].y-a->points[a->e[a->points[i].edges[0]].p1].y);
    a->points[i].z= a->points[a->e[a->points[i].edges[0]].p1].z +(a->points[i].xp)*(a->points[a->e[a->points[i].edges[0]].p2].z-a->points[a->e[a->points[i].edges[0]].p1].z);


  }



  
 

}
