#include "morph.h"

#ifdef debug


int fact (int n) {

  if (n==1) { return 1;} else { return (n*fact (n-1));}

}

void write_geomfile_addedpoint ( char *s, Model *m,int a,int b, int c, int start, int end, Vertex k) { // utilise pour le deboguage;

  int i;

FILE *fp;

  fp = fopen( s, "w" ); 

  fprintf(fp,"COFF\n%d %d %d\n",5,5,0);

  for (i=start;i<end;i++) {

  fprintf(fp,"\t%9.6f\t%9.6f\t%9.6f\t\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n",m->points[i].x, m->points[i].y, m->points[i].z, 0.5, 0.5, 0.5, 0.0);

  }

  //  fprintf(fp,"\t%9.6f\t%9.6f\t%9.6f\t\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n",0.0, 0.0, 0.0, m->points[0].r, m->points[0].g, m->points[0].b, m->points[0].a);
 // ecriture du centre

  fprintf(fp,"\t%9.6f\t%9.6f\t%9.6f\t\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n",k.x, k.y, k.z, m->points[0].r, m->points[0].g, m->points[0].b, m->points[0].a);
  //ecriture du point

  /* from inside...

  for (i=0;i<4;i++) {

	 for (j=i+1;j<4;j++) {

	    fprintf(fp,"3\t%3d\t%3d\t%3d\n",i,j,4);
	 }
  }

  */ 

  // normal...

  for (i=0;i<m->nbf;i++) {


 fprintf(fp,"3\t%3d\t%3d\t%3d\n",m->f[i].p1-4,m->f[i].p2-4,m->f[i].p3-4);

  }

       
  fprintf(fp,"3\t%3d\t%3d\t%3d\n",a-4,b-4,c); // face en plus


}



void write_geomfile_proj ( char *s, Model *m) { // utilise pour le deboguage; renvoit le modele projete

  int i;

FILE *fp;

  fp = fopen( s, "w" ); 

  fprintf(fp,"COFF\n%d %d %d\n",m->nbv,m->nbf,0);

  for (i=0;i<m->nbv;i++) {

  fprintf(fp,"\t%9.6f\t%9.6f\t%9.6f\t\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n",m->points[i].xp, m->points[i].yp, m->points[i].zp, m->points[i].r, m->points[i].g, m->points[i].b, m->points[i].a);

  }

  for (i=0;i<m->nbf;i++) {

    if (m->f[i].p4==-1) { 

 fprintf(fp,"3\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3);
 

} else if (m->f[i].p5==-1) { 

 fprintf(fp,"4\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4);

 }
    else if (m->f[i].p6==-1) {

      fprintf(fp,"5\t%3d\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4,m->f[i].p5);


 } else { 

      fprintf(fp,"6\t%3d\t%3d\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4,m->f[i].p5,m->f[i].p6);

 }

  }

}



void write_inside ( char *s, Model *m) { // aussi utilise pour le deboguage; renvoit le modele "vu de l interieur

  int i,j;

  FILE *fp;

  fp = fopen( s, "w" );

  printf (s);
  
  fprintf(fp,"COFF\n%d %d %d\n",m->nbv+1,(m->nbv)*(m->nbv-1)/2,0);


  //printf("COFF\n%d %d %d\n",m->nbv+1,((m->nbv)*(m->nbv-1))/2,0);



  for (i=0;i<m->nbv;i++) {

  fprintf(fp,"\t%9.6f\t%9.6f\t%9.6f\t\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n",m->points[i].xp, m->points[i].yp, m->points[i].zp, m->points[i].r, m->points[i].g, m->points[i].b, m->points[i].a);

  }

  fprintf(fp,"\t%9.6f\t%9.6f\t%9.6f\t\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n",0.0, 0.0, 0.0, m->points[0].r, m->points[0].g, m->points[0].b, m->points[0].a); // ecriture du centre


  for (i=0;i<m->nbv;i++) {

	 for (j=i+1;j<m->nbv;j++) {

	    fprintf(fp,"3\t%3d\t%3d\t%3d\n",i,j,m->nbv);
	 }
  }
    


}

void write_geomfile ( char *s, Model *m) {

  int i;

  FILE *fp;

  fp = fopen( s, "w" ); 

  fprintf(fp,"COFF\n%d %d %d\n",m->nbv,m->nbf,0);

  for (i=0;i<m->nbv;i++) {

  fprintf(fp,"\t%9.20f\t%9.20f\t%9.20f\t\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n",m->points[i].x, m->points[i].y, m->points[i].z, m->points[i].r, m->points[i].g, m->points[i].b, m->points[i].a);

  }

  fprintf(fp,"\n");


  for (i=0;i<m->nbf;i++) {

    if (m->f[i].p4==-1) { 

 fprintf(fp,"3\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3);
 

} else if (m->f[i].p5==-1) { 

 fprintf(fp,"4\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4);

 }
    else if (m->f[i].p6==-1) {

      fprintf(fp,"5\t%3d\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4,m->f[i].p5);


 } else { 

      fprintf(fp,"6\t%3d\t%3d\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4,m->f[i].p5,m->f[i].p6);

 }

  }

}

#endif

void write_to_geomview ( Model *m) { // utilise pour envoyer directement les donnes  Geomview

  int i;

  printf("COFF\n%d %d %d\n",m->nbv,m->nbf,0);

  for (i=0;i<m->nbv;i++) {

  printf("\t%9.20f\t%9.20f\t%9.20f\t\t%5.3f\t%5.3f\t%5.3f\t%5.3f\n",m->points[i].x, m->points[i].y, m->points[i].z, m->points[i].r, m->points[i].g, m->points[i].b, m->points[i].a);

  }

  printf("\n");


  for (i=0;i<m->nbf;i++) {

    if (m->f[i].p4==-1) { 

 printf("3\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3);
 

} else if (m->f[i].p5==-1) { 

 printf("4\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4);

 }
    else if (m->f[i].p6==-1) {

      printf("5\t%3d\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4,m->f[i].p5);


 } else { 

      printf("6\t%3d\t%3d\t%3d\t%3d\t%3d\t%3d\n",m->f[i].p1,m->f[i].p2,m->f[i].p3,m->f[i].p4,m->f[i].p5,m->f[i].p6);

 }

  }

}



void create_mem_edge (Edge *e, int edgemempage) {

  int k;
  int *t, *u;

  u= e->inter;

  t= (int *) malloc ((e->nbi + edgemempage)*sizeof(int));
  
  for (k=0;k<e->nbi;k++) {

    t[k]=u[k];

  }

  e->inter= t;
  e->nbimax= e->nbi + edgemempage;


  free (u);

}



int create_mem_inter ( Intersection **pointeur, int n, int intermempage) {

#if 0

  int k;
  Intersection *u;

  u= *pointeur;

  *pointeur= (Intersection *) malloc ((n + intermempage)*sizeof(Intersection));

  for (k=0;k<n;k++) {

    (*pointeur)[k]=u[k];

  }

  //*pointeur= t;

  if (n!=0) {

  free (u);

  }

#else

  // au debut, *pointeur doit etre NULL ou un malloc
  *pointeur = realloc( *pointeur, (n + intermempage)*sizeof(Intersection) );

#endif

  return n+ intermempage;


}



void create_mem ( Model *a) { // create mem realloue de la memoire pour les tableaux de vertex si il y a bcp d intersections

  int k;
  Vertex *t,*u;

  u= a->points;

  t= (Vertex *) malloc ((a->maxvtx+a->vtxmempage)*sizeof(Vertex));

  for (k=0;k<a->maxvtx;k++) {

    t[k]=a->points[k];

  }

  a->points= t;
  a->maxvtx= a->maxvtx+a->vtxmempage;

  // FREE the memory used by a->points ... c est a dire u...

  free (u);

}


void write_topology ( Model *M, int a) {

  int i;

  printf("Number of Points: %d\n", M->nbv);
  printf("Number of Edges: %d\n", M->nbe);
  printf("Number of Faces: %d\n", M->nbf);

  printf("\nFace: p1 p2 p3 ; e1 e2 e3\n\n");

  for (i=0;i<M->nbf;i++) { // faces

    printf("%d: %d %d %d ; %d %d %d\n",i, M->f[i].p1+a, M->f[i].p2+a, M->f[i].p3+a, M->f[i].e1, M->f[i].e2, M->f[i].e3);

  }

  printf("\nEdge: p1 p2 ; f1 f2\n\n");

  for (i=0;i<M->nbe;i++) { //edges

    printf("%d: %d %d ; %d %d\n",i, M->e[i].p1+a, M->e[i].p2+a, M->e[i].f1, M->e[i].f2);

  }

  printf("\nVertex: number of edges;\n\n");

  for (i=0;i<M->nbv;i++) { //vertexes

    printf("%d: %d\n",i+a, M->points[i].enb);

  }


}

// create_topology cree la topologie voulue a partir de l information d un fichier geomview
// ce n est pas tres dur.

void create_topology ( Model *Ma) {

  int i, j,k,  bool, current;

  int p1,p2,p3;

  Ma->nbe = 3*(Ma->nbf)/2; // on calcule le nombre d edges a partir des faces

  Ma->e= (Edge *) malloc (Ma->nbe*sizeof(Edge));
  


  for (i=0;i<Ma->nbe;i++) { // cette initialisation est ncessaire... elle sert a dire que les edges ne sont "pas encore crs"

    // apres reflexion je ne suis pas sure qu elle soit necessaire. a voire. Si car on met other_way dedans

    Ma->e[i].p1=-1;
    Ma->e[i].p2=-1;
    Ma->e[i].other_way= 0;

  }


  current=0;

  for (i=0; i<Ma->nbf;i++) {// on boucle sur toutes les faces

    p1= Ma->f[i].p1;
    p2= Ma->f[i].p2;
    p3= Ma->f[i].p3;
    bool = 0;

// creation de l edge e1: c est par DEFINITION l edge reliant e1 a e2.

    for (j=0;j<Ma->points[p1].enb;j++) { // on teste si il a deja ete fait

      k= Ma->points[p1].edges[j]; // k est le numero d edge qu on veut tester

      if ( ( Ma->e[k].p1== p2) | (Ma->e[k].p2== p2) )
	    {  bool=k+1; }
    }
    
    if (bool==0) { // l edge est nouveau
    
      Ma->points[p1].edges[Ma->points[p1].enb]= current;
      Ma->points[p1].enb++;
      Ma->points[p2].edges[Ma->points[p2].enb]= current;
      Ma->points[p2].enb++;
      Ma->e[current].p1= p1;
      Ma->e[current].p2= p2;
      Ma->e[current].f1= i;  
      Ma->f[i].e1= current;
      current++;
    
    }
  
    else { // l edge a deja ete fait, on doit juste updater la deuxieme face de cete edge

      Ma->f[i].e1= bool-1;  
      Ma->e[bool-1].f2= i; }

    bool=0;

    // creation de l edge e2 (meme code...) c est l edge reliant e2 a e3.

    for (j=0;j<Ma->points[p2].enb;j++) {

      k= Ma->points[p2].edges[j]; // k est le numero d edge qu on veut tester

      if ( ( Ma->e[k].p1== p3) | (Ma->e[k].p2== p3) )

   
	{

	bool=k+1;

      }
    }

    if (bool==0) {

      Ma->points[p2].edges[Ma->points[p2].enb]= current;
      Ma->points[p2].enb++;
      Ma->points[p3].edges[Ma->points[p3].enb]= current;
      Ma->points[p3].enb++;
      Ma->e[current].p1= p2;
      Ma->e[current].p2= p3;
      Ma->e[current].f1= i;  
      Ma->f[i].e2= current;
      current++;

    }

    else { 

      Ma->f[i].e2= bool-1;  
      Ma->e[bool-1].f2= i; }

    bool=0;


    // creation de l edge e3 (meme code...) c est l edge reliant e1 a e3.

    for (j=0;j<Ma->points[p3].enb;j++) {

      k= Ma->points[p3].edges[j]; // k est le numero d edge qu on veut tester

      if ( ( Ma->e[k].p1== p1) | (Ma->e[k].p2== p1) ) {

	bool=k+1;

      }
    }

    if (bool==0) {

      Ma->points[p1].edges[Ma->points[p1].enb]= current;
      Ma->points[p1].enb++;
      Ma->points[p3].edges[Ma->points[p3].enb]= current;
      Ma->points[p3].enb++;
      Ma->e[current].p1= p1;
      Ma->e[current].p2= p3;
      Ma->e[current].f1= i;  
      Ma->f[i].e3= current;
      current++;

    }

    else { 

      Ma->f[i].e3= bool-1;  
      Ma->e[bool-1].f2= i; }

  }

}

  //| ((Ma->points[p1].edges[j].p1= p2) )

int readgeomfile(char *namea, Model *Ma, int max_edges) {

  int trash, nbv, nbf,i,ran;
  char *coff;

  float x,y,z;

  FILE *fp;

  coff= (char *) malloc (10*sizeof (char));

	if ( (fp = fopen( namea, "r" )) == NULL ) {
		fprintf(stderr,"Could not open file %s.\n",namea);
		return(0);
	}

	fscanf (fp, "%s", coff);

	fscanf (fp, "%d %d %d", &nbv, &nbf, &trash);

	Ma->points= (Vertex *) malloc (nbv * sizeof(Vertex));
	Ma->f= (Face *) malloc (nbf * sizeof(Face));


	for (i=0; i < nbv;i++) {

	  fscanf (fp, "%f %f %f %f %f %f %f", &x, &y, &z, &Ma->points[i].r, &Ma->points[i].g, &Ma->points[i].b, &Ma->points[i].a);
	  

	  ran= random();
	  Ma->points[i].x= (double) x + ((double) ran * 0.000000000000001); // on ajoute un peu de bruit pour viter les cas pathologiques
	  ran= random();
	  Ma->points[i].y= (double) y + ((double) ran * 0.000000000000001);
	  ran= random();
	  Ma->points[i].z= (double) z + ((double) ran * 0.000000000000001);

	}


	for (i=0; i<nbf;i++) {

	  fscanf (fp, "%d %d %d %d ", &trash, &Ma->f[i].p1, &Ma->f[i].p2, &Ma->f[i].p3);

	  if (trash!=3) { fprintf(stderr,"There is a face that does not have 3 vertex.\n");}

}

	Ma->nbf = nbf;
	Ma->nbv = nbv;

	for (i=0;i<nbf;i++) { // normalement ceci ne sert qu au deboguage

	  Ma->f[i].p4=-1;
	  Ma->f[i].p5=-1;
	  Ma->f[i].p6=-1;

	}



	for (i=0;i< Ma->nbv;i++) {

	  Ma->points[i].edges= (int *) malloc (max_edges*sizeof(int));
	}


	create_topology ( Ma);

	return 1;
}



void update_model (Model *m, int k) { // on update en ajoutant k a tous les pointeurs des edges et des faces sur les points

   int i;

   for (i=0;i<m->nbe;i++) {

     m->e[i].p1= m->e[i].p1+k;
     m->e[i].p2= m->e[i].p2+k;
   }

 for (i=0;i<m->nbf;i++) {

     m->f[i].p1= m->f[i].p1+k;
     m->f[i].p2= m->f[i].p2+k;
     m->f[i].p3= m->f[i].p3+k;
   }

 }

void translate_to_orig (Model *a) { // all points are translated so that the "center" is at (0;0;0)
  
  int i;
  for (i=0;i<a->nbv;i++) {

    a->points[i].x= a->points[i].x - a->center.x;
    a->points[i].y= a->points[i].y - a->center.y;
    a->points[i].z= a->points[i].z - a->center.z;


  }

 }

void translate_from_orig (Model *a) { // all points are translated back to their original coordinates
  
  int i;
  for (i=0;i<a->nbv;i++) {

    a->points[i].x= a->points[i].x + a->center.x;
    a->points[i].y= a->points[i].y + a->center.y;
    a->points[i].z= a->points[i].z + a->center.z;

  }

 }
